

#include <windows.h>
#include <commctrl.h>
#include "custom_font.h"



/* prototype for the dialog box function. */
static BOOL CALLBACK 	DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);



static HWND hwndEdit;
HFONT 		font;
int 		currentfont;

// -------------------------------------------------------[ the font stuct ]
struct C_FONT{
	char 	*fontFileName;		// the font filename, as it appear in your dir.
	char 	*fontSystemName;	// the font system name, as it appear in your 'windows/fonts/' dir.
	int 	fontSize;			// the default size for the font.
	};

typedef struct C_FONT C_FONTSTRUCT;



// -------------------------------------------------------[ the font data ]
C_FONTSTRUCT myfont[3] = {
	{ "nu.fon" , "nu", 11 },
	{ "bmjoint.ttf" , "bm joint a17" , 17},
	{ "bmmaze.ttf" , "bm maze a9" , 9}
};








// -------------------------------------------------------[ Program Entry Point ]
int APIENTRY WinMain(HINSTANCE hinst, HINSTANCE hinstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS wc;
	INITCOMMONCONTROLSEX cc;

	memset(&wc,0,sizeof(wc));
	wc.lpfnWndProc = DefDlgProc;
	wc.cbWndExtra = DLGWINDOWEXTRA;
	wc.hInstance = hinst;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wc.lpszClassName = "_ Custom.Font_";
	RegisterClass(&wc);
	memset(&cc,0,sizeof(cc));
	cc.dwSize = sizeof(cc);
	cc.dwICC = 0xffffffff;
	InitCommonControlsEx(&cc);



	return DialogBox(hinst, MAKEINTRESOURCE(ID_DLG), NULL, (DLGPROC) DialogFunc);

}



// -------------------------------------------------------[ the set font function ]
void SetCustomFont(HWND hwndCtrl, C_FONTSTRUCT this)
{


	// Add our custom font to the system font list
	// We use a relative path here.
	AddFontResource(this.fontFileName);

	// Create the font to be used by our control.
	font = CreateFont(
   			this.fontSize, 0, 0, 0,
   			10,
   			FALSE, FALSE, FALSE,
   			DEFAULT_CHARSET,
   			OUT_DEFAULT_PRECIS,
   			CLIP_DEFAULT_PRECIS,
   			DEFAULT_QUALITY,
   			DEFAULT_PITCH,
   			this.fontSystemName
   			);

	// Assign the font
	SendMessage(hwndCtrl, WM_SETFONT, (WPARAM) font, MAKELPARAM(TRUE, 0));

	SetFocus(hwndCtrl);

}



// -------------------------------------------------------[ Dialog Init ]
static int InitializeApp(HWND hDlg,WPARAM wParam, LPARAM lParam)
{




	hwndEdit = GetDlgItem(hDlg,ID_EDIT);
	SetWindowText(hwndEdit,"test\r\nthis is an edit control \r\nwith program generated text");

	SetCustomFont(hwndEdit,myfont[2]);


	return 1;
}



// -------------------------------------------------------[ the dialog procedure ]
static BOOL CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{


	int 	success;



	switch (msg) {

	// -----------[ handle dialog init message ]
	case WM_INITDIALOG:
		success = InitializeApp(hwndDlg,wParam,lParam);
		break;

	// -----------[ handle dialog close message ]
	case WM_CLOSE:
		RemoveFontResource(myfont[currentfont].fontFileName);
		EndDialog(hwndDlg,0);
		break;

	// -----------[ handle menu change ]
	case WM_COMMAND:

		switch(wParam){
			case ID_NU:
				hwndEdit = GetDlgItem(hwndDlg,ID_EDIT);
				RemoveFontResource(myfont[currentfont].fontFileName);
				SetCustomFont(hwndEdit,myfont[0]);
				currentfont = 0;
				break;
			case ID_JOINT:
				hwndEdit = GetDlgItem(hwndDlg,ID_EDIT);
				RemoveFontResource(myfont[currentfont].fontFileName);
				SetCustomFont(hwndEdit,myfont[1]);
				currentfont = 1;
				break;
			case ID_FEATHER:
				hwndEdit = GetDlgItem(hwndDlg,ID_EDIT);
				RemoveFontResource(myfont[currentfont].fontFileName);
				SetCustomFont(hwndEdit,myfont[2]);
				currentfont = 2;
				break;
		}
	}

	return 0;

}
